<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [noicejs](./noicejs.md)

## noicejs package

## Classes

|  Class | Description |
|  --- | --- |
|  [BaseError](./noicejs.baseerror.md) | Base class for typed errors, adding nested errors (causes) to the stack. |
|  [ConsoleLogger](./noicejs.consolelogger.md) | <p>Logger implementation using the console.</p><p>Works in the browser or node.</p> |
|  [Container](./noicejs.container.md) | This is an exceptionally minimal DI container. |
|  [ContainerBoundError](./noicejs.containerbounderror.md) | Error indicating that this container is already bound and cannot be bound again. |
|  [ContainerNotBoundError](./noicejs.containernotbounderror.md) | Error indicating that this container is not bound yet and not ready to be used. |
|  [DescriptorNotFoundError](./noicejs.descriptornotfounderror.md) | Error indicating that the target descriptor could not be found on the decorator target. |
|  [InvalidProviderError](./noicejs.invalidprovidererror.md) | <p>Error indicating that the container was able to find a provider, but did not understand the provider type and could not use it to fulfill the dependency.</p><p>This should not normally occur, unless custom provider types are in use.</p> |
|  [InvalidTargetError](./noicejs.invalidtargeterror.md) | Error indicating that the decorator target is not valid. |
|  [LoggerNotFoundError](./noicejs.loggernotfounderror.md) | Error indicating that a debug method has been called, but no logger was registered for debugging. |
|  [MissingValueError](./noicejs.missingvalueerror.md) | Error indicating that a required value is missing. |
|  [Module](./noicejs.module.md) | Provides a set of dependencies, bound in the <code>configure</code> method. |
|  [NullLogger](./noicejs.nulllogger.md) | Logger implementation that consumes input and produces no output. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [LogLevel](./noicejs.loglevel.md) | Available log levels. |
|  [ProviderType](./noicejs.providertype.md) | Providers for a particular contract. |

## Functions

|  Function | Description |
|  --- | --- |
|  [constructWithContainer(container)](./noicejs.constructwithcontainer.md) | Permanently attach a container to all instances of this class. |
|  [contractName(c)](./noicejs.contractname.md) | <p>Get the standard name for a contract (usually a constructor).</p><p>This accepts strings and symbols, so if a function is not provably a constructor, simply pass the name.</p> |
|  [getInject(target)](./noicejs.getinject.md) | Get attached dependencies. |
|  [getProvides(target)](./noicejs.getprovides.md) | Get dependencies provided by this previously-decorated target. |
|  [Inject(needs)](./noicejs.inject.md) | Injection decorator for classes. |
|  [invokeWithContainer(container, target)](./noicejs.invokewithcontainer.md) | Permanently attach a container to all invocations of this function. |
|  [isConstructor(it)](./noicejs.isconstructor.md) | Typeguard for constructors. Only really validates that <code>it</code> is a function. |
|  [logWithLevel(logger, level, options, msg)](./noicejs.logwithlevel.md) | Switch helper to invoke log methods based on variable log level. Dispatches a call to the appropriate log level method. |
|  [Provides(provides)](./noicejs.provides.md) | Decorator for methods that can resolve or provide some dependency. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [BaseOptions](./noicejs.baseoptions.md) | Base interface for all constructor options. |
|  [Constructor](./noicejs.constructor.md) | Some constructor taking options as the first parameter. |
|  [Logger](./noicejs.logger.md) | Log interface to fit console or bunyan. |
|  [ModuleOptions](./noicejs.moduleoptions.md) | Required options for modules. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [Contract](./noicejs.contract.md) | A contract identifier or concrete constructor. |
|  [Provider](./noicejs.provider.md) | Provider definitions. |

