import { contractName, isConstructor } from './Container.js';
/**
 * Convert an InjectedDependency into a regular Dependency
 */
export function resolveDepends(deps) {
    return deps.map((contract) => {
        if (isConstructor(contract)) {
            return {
                contract,
                name: contractName(contract),
            };
        }
        if (typeof contract === 'string') {
            return {
                contract,
                name: contract,
            };
        }
        if (typeof contract === 'symbol') {
            return {
                contract,
                name: contract,
            };
        }
        return contract;
    });
}
//# sourceMappingURL=Dependency.js.map