import { ContractName } from './Container.js';
export interface Binding {
    key: string;
    name: ContractName;
}
export declare const fieldSymbol: unique symbol;
/**
 * Get attached dependencies.
 *
 * @param target - the previously-decorated target
 *
 * @public
 */
export declare function getFields(target: object): Array<Binding>;
export declare function getTargetOrCtor(target: object): any;
/**
 * Injection decorator for classes.
 *
 * @param needs - dependencies required by the decorated target
 *
 * @public
 */
export declare function Field(gets: ContractName): (target: any, key?: string, _providedDesc?: PropertyDescriptor) => void;
export interface FieldValues {
    [K: ContractName]: any;
}
export declare function injectFields(target: object, values: FieldValues): void;
//# sourceMappingURL=Field.d.ts.map