import { Dependency, InjectedDependency } from './Dependency.js';
export declare const injectionSymbol: unique symbol;
/**
 * Get attached dependencies.
 *
 * @param target - the previously-decorated target
 *
 * @public
 */
export declare function getInject(target: any): Array<Dependency>;
/**
 * Injection decorator for classes.
 *
 * @param needs - dependencies required by the decorated target
 *
 * @public
 */
export declare function Inject(...needs: Array<InjectedDependency>): (target: any, key?: string, providedDesc?: PropertyDescriptor) => void;
export declare function InjectWithFields(...needs: Array<InjectedDependency>): (target: any, key?: string, providedDesc?: PropertyDescriptor) => void;
//# sourceMappingURL=Inject.d.ts.map