import { Dependency, InjectedDependency } from './Dependency.js';
export declare const providesSymbol: unique symbol;
/**
 * Get dependencies provided by this previously-decorated target.
 *
 * @param target - the decorated target
 *
 * @public
 */
export declare function getProvides(target: any): Array<Dependency>;
/**
 * Decorator for methods that can resolve or provide some dependency.
 *
 * @public
 */
export declare function Provides<TInjected>(...provides: Array<InjectedDependency>): (target: any, key: string, providedDesc?: PropertyDescriptor) => void;
//# sourceMappingURL=Provides.d.ts.map