import { BaseError } from './BaseError.js';
/**
 * Error indicating that the container was able to find a provider, but did not understand the provider type and could
 * not use it to fulfill the dependency.
 *
 * This should not normally occur, unless custom provider types are in use.
 *
 * @public
 */
export declare class InvalidProviderError extends BaseError {
    constructor(msg?: string, ...nested: Array<Error>);
}
//# sourceMappingURL=InvalidProviderError.d.ts.map