import { Logger } from './Logger.js';
/**
 * Logger implementation using the console.
 *
 * Works in the browser or node.
 *
 * @public
 */
export declare class ConsoleLogger implements Logger {
    /**
     * Global instance for users needing no customization.
     */
    static readonly global: ConsoleLogger;
    /**
     * Create a child logger.
     */
    child(): ConsoleLogger;
    /**
     * Log a message at debug level.
     */
    debug(...params: Array<unknown>): void;
    /**
     * Log a message at info level.
     */
    info(...params: Array<unknown>): void;
    /**
     * Log a message at warning level.
     */
    warn(...params: Array<unknown>): void;
    /**
     * Log a message at error level.
     *
     * Writes to stdout in node, appears as a red message in chrome, etc.
     */
    error(...params: Array<unknown>): void;
}
//# sourceMappingURL=ConsoleLogger.d.ts.map