/**
 * Logger implementation using the console.
 *
 * Works in the browser or node.
 *
 * @public
 */
export class ConsoleLogger {
    /**
     * Create a child logger.
     */
    child() {
        return ConsoleLogger.global;
    }
    /* eslint-disable no-console */
    /**
     * Log a message at debug level.
     */
    debug(...params) {
        console.debug(...params);
    }
    /**
     * Log a message at info level.
     */
    info(...params) {
        console.info(...params);
    }
    /**
     * Log a message at warning level.
     */
    warn(...params) {
        console.warn(...params);
    }
    /**
     * Log a message at error level.
     *
     * Writes to stdout in node, appears as a red message in chrome, etc.
     */
    error(...params) {
        console.error(...params);
    }
}
/**
 * Global instance for users needing no customization.
 */
ConsoleLogger.global = new ConsoleLogger();
//# sourceMappingURL=ConsoleLogger.js.map