/* eslint-disable @typescript-eslint/unified-signatures, @typescript-eslint/no-explicit-any */
/**
 * Available log levels.
 *
 * @public
 */
export var LogLevel;
(function (LogLevel) {
    // normal enum names
    LogLevel["Debug"] = "debug";
    LogLevel["Error"] = "error";
    LogLevel["Info"] = "info";
    LogLevel["Warn"] = "warn";
    // capital slack-style names
    LogLevel["DEBUG"] = "debug";
    LogLevel["ERROR"] = "error";
    LogLevel["INFO"] = "info";
    LogLevel["WARN"] = "warn";
})(LogLevel || (LogLevel = {}));
/**
 * Switch helper to invoke log methods based on variable log level. Dispatches a call to the appropriate log level
 * method.
 *
 * @public
 */
export function logWithLevel(logger, level, options, msg) {
    switch (level) {
        case 'debug':
            logger.debug(options, msg);
            return;
        case 'info':
            logger.info(options, msg);
            return;
        case 'warn':
            logger.warn(options, msg);
            return;
        case 'error':
        default:
            logger.error(options, msg);
            return;
    }
}
//# sourceMappingURL=Logger.js.map