import { BaseOptions, Constructor, Contract, ContractName } from '../Container.js';
import { Module, ModuleOptions } from '../Module.js';
export declare type ProviderValue<TReturn, TOptions extends BaseOptions> = TReturn | Constructor<TReturn, TOptions>;
export declare type ProviderMap<TReturn, TOptions extends BaseOptions> = Map<Contract<TReturn, TOptions>, ProviderValue<TReturn, TOptions>>;
export declare type ProviderMapLike = ProviderMap<unknown, BaseOptions> | {
    [key: ContractName]: ProviderValue<unknown, BaseOptions>;
};
export interface MapModuleOptions {
    providers: ProviderMapLike;
}
/**
 * Reference module that provides dependencies from a map-like of instances or constructors.
 *
 * To add providers to this module, extend it with `@Provides` methods.
 *
 * @public
 */
export declare class MapModule extends Module {
    private readonly providerMap;
    constructor(options: MapModuleOptions);
    configure(options: ModuleOptions): Promise<void>;
}
//# sourceMappingURL=MapModule.d.ts.map