import { Cache, Filesystem } from '../index.js';
import { Module } from '../../../src/index.js';
export class LocalCache extends Cache {
    async get(path, ttl, fallback) {
        return 'hello world!';
    }
}
export class LocalFilesystem extends Filesystem {
    async get(path) {
        throw new Error('file not found!');
    }
}
export class LocalModule extends Module {
    async configure() {
        this.bind(Cache.name.toLowerCase()).toConstructor(LocalCache);
        this.bind(Filesystem.name.toLowerCase()).toConstructor(LocalFilesystem);
    }
}
//# sourceMappingURL=index.js.map